/*
 * AVDS2MATLABDef.h
 *      
 *          Copyright (C) 2000 RasSimTech Ltd. 
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version. 
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU General Public License for more details. 
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
 */


#ifndef AVDS2MATLAB_H
#define AVDS2MATLAB_H

#define SIMULATION_STOPPED 0
#define SIMULATION_RUNNING 1
/////////////////////////////////////////////////////////////////
// AVDS/MATLAB FCS sample Shared Memory Connections
/////////////////////////////////////////////////////////////////
// To AVDS FCS
#define ID_TO_AVDS_FCS 1

#define TO_AVDS_ELEVATOR_CMD_RAD 0
#define TO_AVDS_AILERON_CMD_RAD 1
#define TO_AVDS_RUDDER_CMD_RAD 2
#define TO_AVDS_THROTTLE_CMD 3
#define TO_AVDS_FCS_01 4
#define TO_AVDS_FCS_02 5
#define TO_AVDS_FCS_03 6
#define TO_AVDS_FCS_04 7
#define TO_AVDS_FCS_05 8
#define TO_AVDS_FCS_06 9
#define TO_AVDS_FCS_07 10
#define TO_AVDS_FCS_08 11
#define TO_AVDS_FCS_09 12
#define TO_AVDS_FCS_10 13
#define TO_AVDS_TOTAL_FCS 14

// To MATLAB FCS
#define ID_TO_MATLAB_FCS 2

#define TO_MATLAB_RUNNING_FCS 0	/* Must ==0 */
#define TO_MATLAB_STICK_PITCH 1
#define TO_MATLAB_STICK_ROLL 2
#define TO_MATLAB_STICK_YAW 3
#define TO_MATLAB_STICK_THROTTLE 4
#define TO_MATLAB_P_RAD_PER_SEC 5
#define TO_MATLAB_Q_RAD_PER_SEC 6
#define TO_MATLAB_R_RAD_PER_SEC 7
#define TO_MATLAB_TIME_ELAPSED_SEC_FCS 8
#define TO_MATLAB_FCS_01 9
#define TO_MATLAB_FCS_02 10
#define TO_MATLAB_FCS_03 11
#define TO_MATLAB_FCS_04 12
#define TO_MATLAB_FCS_05 13
#define TO_MATLAB_FCS_06 14
#define TO_MATLAB_FCS_07 15
#define TO_MATLAB_FCS_08 16
#define TO_MATLAB_FCS_09 17
#define TO_MATLAB_FCS_10 18
#define TO_MATLAB_TOTAL_FCS 19


/////////////////////////////////////////////////////////////////
// AVDS/MATLAB AC sample Shared Memory Connections
/////////////////////////////////////////////////////////////////

// To AVDS AC
#define ID_TO_AVDS_AC 3

#define TO_AVDS_POSITION_NORTH_FEET 0
#define TO_AVDS_POSITION_EAST_FEET 1
#define TO_AVDS_ALTITUDE_FEET 2
#define TO_AVDS_PHI_RAD 3
#define TO_AVDS_THETA_RAD 4
#define TO_AVDS_PSI_RAD 5
#define TO_AVDS_ALPHA_RAD 6
#define TO_AVDS_BETA_RAD 7
#define TO_AVDS_G 8
#define TO_AVDS_V 9
#define TO_AVDS_M 10
#define TO_AVDS_DELTA_RUDDER_RAD 11
#define TO_AVDS_DELTA_ELEVATOR_RAD 12
#define TO_AVDS_DELTA_AILERION_RAD 13
#define TO_AVDS_ENGINE_LEVEL 14
#define TO_AVDS_AC_01 15
#define TO_AVDS_AC_02 16
#define TO_AVDS_AC_03 17
#define TO_AVDS_AC_04 18
#define TO_AVDS_AC_05 19
#define TO_AVDS_AC_06 20
#define TO_AVDS_AC_07 21
#define TO_AVDS_AC_08 22
#define TO_AVDS_AC_09 23
#define TO_AVDS_AC_10 24
#define TO_AVDS_TOTAL_AC 25

// To MATLAB AC
#define ID_TO_MATLAB_AC 4

#define TO_MATLAB_RUNNING_AC 0		/* Must ==0 */
#define TO_MATLAB_ELEVATOR_CMD 1
#define TO_MATLAB_AILERON_CMD 2
#define TO_MATLAB_RUDDER_CMD 3
#define TO_MATLAB_THROTTLE_CMD 4
#define TO_MATLAB_TIME_ELAPSED_SEC_AC 5
#define TO_MATLAB_AC_01 6
#define TO_MATLAB_AC_02 7
#define TO_MATLAB_AC_03 8
#define TO_MATLAB_AC_04 9
#define TO_MATLAB_AC_05 10
#define TO_MATLAB_AC_06 11
#define TO_MATLAB_AC_07 12
#define TO_MATLAB_AC_08 13
#define TO_MATLAB_AC_09 14
#define TO_MATLAB_AC_10 15
#define TO_MATLAB_TOTAL_AC 16



#endif	//AVDS2MATLAB_H