echo off

rem %% This batch file converts DTED level 0 (DTED0) binary terrain file to AVDS terrain format files
rem %%
rem %%
rem %%


rem %% DTED0Convert.exe - converts DTED0 elevation files to AVDS format and adds shading for a set time of day
rem %% USAGE:
rem %%    DTED0Convert.exe DTED0FileName LatitudeMin LatitudeMax LongitudeMin LongitudeMax NumberDataRows NumberDataColumns TimeOfDay
rem %% 
rem %% where:
rem %%    DTED0FileName - the name of the file that contains the DTED0 data to convert
rem %%    LatitudeMin - Minimum Latitude of the DTED0 data (in whole degrees [-90,90])
rem %%    LatitudeMax - Maximum Latitude of the DTED0 data (in whole degrees [-90,90])
rem %%    LongitudeMin - MinimumLongitude of the DTED0 data (in whole degrees [-180,180])
rem %%    LongitudeMax - Maximum Longitude of the DTED0 data (in whole degrees [-180,180])
rem %%    NumberDataRows - Number of rows of data in the DTED0 file
rem %%    NumberDataColumns - Number of columns of data in the DTED0 file
rem %%    TimeOfDay - Time of day for calculating shading (based on 24-hour clock with decimal, i.e. 14.5 is 2:30 pm)
rem %% 
rem %% 

call ..\bin\DTED0Convert.exe SFBay.bin  37.0 38.0 -123.0 -121.0 120 240 16.5

rem %% remove temporary files
del *.tmp
del *.c32


echo on